
structure StupidBot :> ROBOT =
struct
    open Comm
    open World

    type mind = unit

    fun init _ _ = ()

    fun move (board as BOARD{layout, packages, robots, cap = (cap, _)}) _ () (me as ROBOT{loc as (r, c),...}) =
	let
	    fun eval ((dr, dc), m) =
		case sub layout (r + dr, c + dc) of
		    SPOT {space = Dot true, ...} => (if RobUtil.carried board me <= (cap div 2) then 150 else 50, m)
		  | SPOT {space = Dot false, ...} => (60, m)
		  | SPOT {space = Water, ...} => (~1000, m)
		  | SPOT {space = Wall, ...} => (0, m)
	    
	    val moves = map eval [((1,0),  N),
				  ((~1,0), S),
				  ((1,0),  E),
				  ((~1,0), W)]

	    val l = ListUtil.sort (ListUtil.byfirst Int.compare) moves
	in
	    ((), 1, Move (#2 (hd l)))
	end

end
