
structure Util :> UTIL =
struct

  val debug = Params.flag false (SOME ("-time", 
				       "Turn on timing messages.")) "time"


  fun uncurry f (a,b) = f a b
  fun curry f a b = f (a, b)

  fun both f g x = (f x, g x)
  fun doboth f g x = ignore (f x; g x)

  fun for lo hi f =
      if lo > hi then ()
      else (f lo; for (lo + 1) hi f)

  fun ford lo hi b f =
      if lo > hi then b
      else (ford (lo + 1) hi (f (lo, b)) f)

  datatype ('a, 'b) sum = A of 'a | B of 'b

  fun pr s = TextIO.output (TextIO.stdErr, String.concat s)

  fun time name f x = (if !debug then (pr ["timing ", name, " starts: ", Time.toString (Time.now ()), "\n"]) else ();
                       let
			   val r = f x
                       in
			   if !debug then (pr ["       ", name, "  stops: ", Time.toString (Time.now ()), "\n"]) else ();
			       r
                       end)
                     
end
